<template>
  <div>
    <BasicTable @register="registerTable" :rowSelection="rowSelection">
      <template #tableTitle>
        <a-button preIcon="ant-design:plus-outlined" type="primary" @click="handleAdd">新增</a-button>
        <a-button type="primary" preIcon="ant-design:export-outlined" @click="onExportXls"> 导出</a-button>
        <j-upload-button type="primary" preIcon="ant-design:import-outlined" @click="onImportXls">导入</j-upload-button>
        <a-dropdown v-if="selectedRowKeys.length > 0">
          <template #overlay>
            <a-menu>
              <a-menu-item key="1" @click="batchHandleDelete">
                <Icon icon="ant-design:delete-outlined" />
                删除
              </a-menu-item>
            </a-menu>
          </template>
          <a-button
            >批量操作
            <Icon style="fontsize: 12px" icon="ant-design:down-outlined" />
          </a-button>
        </a-dropdown>
      </template>
      <template #action="{ record }">
        <TableAction :actions="getActions(record)" :dropDownActions="getDropDownAction(record)" />
      </template>
    </BasicTable>
    <DeviceModal @register="registerModal" @saveOrUpdate="saveOrUpdateHandler" :showtTab="showtTab" />
  </div>
</template>

<script lang="ts" name="system-user" setup>
  //ts语法
  import { ref, provide, reactive, toRaw, defineExpose } from 'vue';
  import { BasicTable, TableAction } from '/@/components/Table';
  import { useModal } from '/@/components/Modal';
  import DeviceModal from './DeviceModal.vue';
  // import { getToken } from '/@/utils/auth';
  // import { useGlobSetting } from '/@/hooks/setting';
  import { useListPage } from '/@/hooks/system/useListPage';
  import { useMessage } from '/@/hooks/web/useMessage';
  const $message = useMessage();
  const props = defineProps({
    columns: {
      type: Array,
      required: true,
      default: () => [],
    },
    searchFormSchema: {
      type: Array,
      required: true,
      default: () => [],
    },
    formSchema: {
      type: Array,
      required: true,
    },
    list: {
      type: Function,
      required: true,
    },
    getImportUrl: {
      type: String,
      required: true,
    },
    getExportUrl: {
      type: String,
      required: true,
    },
    deleteById: {
      type: Function,
      required: true,
    },
    batchDelete: {
      type: Function,
      // required: true,
    },
    saveOrUpdate: {
      type: Function,
      required: true,
    },
    showtTab: {
      type: Boolean,
      default: false,
    },
    designScope: {
      type: String,
    },
    title: {
      type: String,
    },
    deviceType: {
      type: String,
    },
  });
  // debugger  
  const isUpdate = ref(false);
  const record = reactive({});

  provide('formSchema', props.formSchema);
  provide('isUpdate', isUpdate);
  provide('formData', record);
  provide('deviceType', props.deviceType);
  // const glob = useGlobSetting();
  const [registerModal, { openModal, closeModal }] = useModal();

  // 列表页面公共参数、方法
  const { prefixCls, tableContext, onExportXls, onImportXls, doRequest } = useListPage({
    designScope: props.designScope,
    tableProps: {
      title: props.title,
      api: props.list,
      columns: props.columns as any[],
      size: 'small',
      formConfig: {
        labelWidth: 200,
        schemas: props.searchFormSchema as any[],
      },
      actionColumn: {
        width: 180,
      },
      beforeFetch: (params) => {
        return Object.assign({ column: 'createTime', order: 'desc' }, params);
      },
    },
    exportConfig: {
      name: props.title,
      url: props.getExportUrl,
    },
    importConfig: {
      url: props.getImportUrl,
    },
  });

  //注册table数据
  const [registerTable, { reload }, { rowSelection, selectedRowKeys }] = tableContext;

  const saveOrUpdateHandler = async (params) => {
    try {
      await props.saveOrUpdate(params, isUpdate.value);
      !props.showtTab ? closeModal() : '';
      await doRequest(props.list, { confirm: false });
    } catch (error) {
      $message.createMessage.error('保存失败，请联系管理员');
    }
  };

  /**
   * 新增事件
   */
  function handleAdd() {
    for (let key in record) {
      delete record[key];
    }
    isUpdate.value = false;
    openModal(true);
  }

  /**
   * 编辑事件
   */
  function handleEdit(data) {
    isUpdate.value = true;
    Object.assign(record, toRaw(data));
    openModal(true, {
      record,
    });
  }

  /**
   * 删除事件
   */
  async function handleDelete(record) {
    await props.deleteById({ id: record }, reload);
  }

  /**
   * 批量删除事件
   */
  async function batchHandleDelete() {
    doRequest(() => props.batchDelete({ ids: selectedRowKeys.value }));
  }
  /**
   * 查看
   */
  // function handleDetail(record) {
  //   iframeUrl.value = `${glob.uploadUrl}/sys/annountCement/show/${record.id}?token=${getToken()}`;
  //   openDetail(true);
  // }
  /**
   * 操作列定义
   * @param record
   */
  function getActions(record) {
    return [
      {
        label: '编辑',
        onClick: handleEdit.bind(null, record),
      },
      {
        label: '删除',
        popConfirm: {
          title: '是否确认删除',
          confirm: handleDelete.bind(null, record),
        },
      },
      // {
      //   label: '查看',
      //   onClick: handleDetail.bind(null, record),
      // },
    ];
  }
  /**
   * 下拉操作栏
   */
  function getDropDownAction(record) {
    return [
      // {
      //   label: '删除',
      //   popConfirm: {
      //     title: '是否确认删除',
      //     confirm: handleDelete.bind(null, record),
      //   },
      // },
      // {
      //   label: '查看',
      //   onClick: handleDetail.bind(null, record),
      // },
    ];
  }
  defineExpose({
    doRequest,
  });
</script>

<style scoped lang="less">
  // :deep(.ant-table-header){
  //   background-color:transparent;
  //   height: 0;
  // }
  // :deep(.jeecg-basic-table .ant-table-wrapper){
  //   background-color: #ffffff00;
  // }
  // :deep(.ant-table-body) {
  //   height: auto !important;
  // }
  // :deep(.ant-table){
  //   background-color: #ffffff00 !important;
  // }
  // :deep(.ant-table-thead > tr > th){
  //   background-color:transparent
  // }
  // :deep(.ant-table-body > tr > th){
  //   background-color:transparent
  // }
  // :deep(.ant-table-body > tr > td){
  //   border: none;
  // }
  // :deep(.ant-table-fixed-header > .ant-table-content > .ant-table-scroll > .ant-table-body){
  //   background-color:transparent
  // }
  // :deep(.jeecg-basic-table-row__striped td){
  //   background-color: transparent;
  // }
</style>
